
function LliurexGuard(){
	var self=this;
	this.show_advanced=false;
	this.show_menu=false;
	
	this.setList=function setList(file, content){
		$.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
				methodName: 'set_list_file',
					params: [[sessionStorage.username , sessionStorage.password], "LliurexGuardEasy", file, content],
	        	    success: function(response,status,jqXHR){
					if (response[0] == 0){
						bootbox.dialog({
								message: file +i18n.gettext("main.saved.restart"),
								title: i18n.gettext("restart.service"),
								buttons: {
									yes: {
										label: i18n.gettext("yes"),
										className: "btn-success",
										callback: function(){
											self.restartService("Custom");
											},
									},
									no: {
										label: i18n.gettext("no"),
										className: "btn-danger",
										callback: function() {}
									}
								}
										
							});
					
					}
					else{
						bootbox.alert (file + i18n.gettext("main.not.saved"));
					}
				},
						error: function(jqXHR, status, error) {
								bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
					}
		})
	}
	
	this.restartService=function restartService(template){
		$("#loaded_config").html(i18n.gettext("showing.cfg.for")+template);
		$("#black").show();
		$.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'restart_proxy',
			params: [[sessionStorage.username , sessionStorage.password], "LliurexGuardEasy"],
			success: function(response,status,jqXHR){
			if (response[0]['status'] == true)
				bootbox.alert(i18n.gettext("main.restart"));
			else{
				text="<div class='ErrorTitle'>"+i18n.gettext("restart.exception")+"</div>";
				text=text+"<div class='ErrorMessages'>" +i18n.gettext("srv.response")+"</div>";
				text=text+"<div class='ErrorContent'>"+response['0']['msg']+"</div>"
				bootbox.alert(text);
				}
				
			$("#black").hide();
			},
			error: function(jqXHR, status, error) {
				bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
			}
		})
	}
	
	this.saveFile=function saveFile(file){
		var result = document.getElementById(file);
		var content = result.value.split("\n");
		switch (file){
			case "allow-dst-domains.conf":
				break;
			case "deny-dst-domains.conf":
									if (self.validateDomain(content)){
										bootbox.alert (file+i18n.gettext("main.domain.format.not.valid"));
										return file+"Domain format is not valid";
									}
									//alert (file+i18n.gettext("Domain is correct"));
									break;
			
			case "allow-SSL-ports.conf":
									if (self.validatePorts(content)){
										bootbox.alert (file+i18n.gettext("port.error"));
										return file+i18n.gettext("port.error");
									}
									
									// Remove white lines and check if port n4d is added by user
									n4d_added=false;
									for (i in content){
										if ((content[i])=="") content.splice(i,1);
										if (content[i]=="9779") n4d_added=true;
										}
																		
									// Add  N4D port if not added
									if (!n4d_added) content.push("9779");
									break;
		}
		
		// Saving
		return self.setList(file, content);
	}
	
	this.validateDomain=function validateDomain(content){
		return 0;
	}
	
	this.validatePorts=function validatePorts(ports){
	for (x in ports){
		if (ports[x] > 100000){
			return 1
		}
	}
	return 0;
	}

	this.getList=function getList(setfunc, callback){
		filelist=["allow-dst-domains.conf","deny-dst-domains.conf","allow-SSL-ports.conf", "deny-dst-domains-expr.conf"];
            $.xmlrpc({
				url: 'https://'+sessionStorage.server+':9779',
                methodName: 'load_list_file',
                params: [[sessionStorage.username , sessionStorage.password], "LliurexGuardEasy", filelist],
                success: function(response,status,jqXHR){
					for ( x in response[0] ) {
						var file=filelist[x];
						switch (file) {
							case "allow-SSL-ports.conf":
								var label=$(document.createElement("div")).html(i18n.gettext('allowed.ports')).addClass("labeltext");
								//if !($("#"+file))
								var help_button=$(document.createElement("div")).addClass("helpbutton");
								$(help_button).bind("click", function(){
									self.showhelp("allow_ssl_ports")}
								);
								var label_and_help=$(document.createElement("div")).addClass("rulesTitle");
								label_and_help.append(label);
								label_and_help.append(help_button);
								var textarea=$(document.createElement("textarea")).attr("id", file).attr("name","comments");
								$(textarea).bind("keypress",function(){
									return event.charCode >= 48 && event.charCode <= 57 || event.charCode <= 13;
									})
								
								
									
								dstdiv=$("#AllowedPorts")
								/*$("#main").append(AllowePortsLabel);
								$("#main").append(textAreaAllowedPorts);*/
		                    //Check  the content of the box must be numeric
							//var label=$(document.createElement("label").html(i18n.gettext('Advanced options')));
							/*$("#main").append("<label onclick=advancedOptions()>"+i18n.gettext('Advanced options')+"</label><br>");
							//$("#main").append("---------------------------------------------------------------------------<br>");
        	                $("#main").append(i18n.gettext('Allowed ports')+": "+filelist[x]+"<br>");
                	        $("#main").append("<textarea id='"+filelist[x]+"' onkeypress='return event.charCode >= 48 && event.charCode <= 57 || event.charCode <= 13' name='comments' cols='25' rows='5'>");*/
       
                            break;
						
							case "deny-dst-domains-expr.conf":
								var label=$(document.createElement("div")).html(i18n.gettext('not.allowed.domains.expr')).addClass("labeltext"); // UNTRANSLATED
								var help_button=$(document.createElement("div")).addClass("helpbutton");
								$(help_button).bind("click", function(){
									self.showhelp("deny_dst_domains_expr")}
								);
								var label_and_help=$(document.createElement("div")).addClass("rulesTitle");
								label_and_help.append(label);
								label_and_help.append(help_button);
								
								var textarea=$(document.createElement("textarea")).attr("id", file).attr("name","comments");
								dstdiv=$("#DenyDomainsExpr")
								
								break;
						
        					case "allow-dst-domains.conf":
							//var label=$(document.createElement("label").html(i18n.gettext('Advanced options')));								
								var label= $(document.createElement("div")).html(i18n.gettext('allowed.domains')).addClass("labeltext");
								var help_button=$(document.createElement("div")).addClass("helpbutton");
								$(help_button).bind("click", function(){
									self.showhelp("allow_dst_domains")}
								);
								var label_and_help=$(document.createElement("div")).addClass("rulesTitle");
								label_and_help.append(label);
								label_and_help.append(help_button);
					
								var textarea=$(document.createElement("textarea")).attr("id", file).attr("name","comments");
								dstdiv=$("#AllowedDomains")
								
								break;
							case "deny-dst-domains.conf":
								var label=$(document.createElement("div")).html(i18n.gettext('not.allowed.domains')).addClass("labeltext");
								var help_button=$(document.createElement("div")).addClass("helpbutton");
								$(help_button).bind("click", function(){
									self.showhelp("deny_dst_domains")}
								);
								var label_and_help=$(document.createElement("div")).addClass("rulesTitle");
								label_and_help.append(label);
								label_and_help.append(help_button);
								
								var textarea=$(document.createElement("textarea")).attr("id", file).attr("name","comments");
								dstdiv=$("#DenyDomains")
								
                                break;
						 }
						 
						 dstdiv.append(label_and_help);
						 dstdiv.append(textarea);
						 
						 var button=$(document.createElement("button")).html(i18n.gettext("btsave")).attr("id",file).addClass("ui-button");
						 dstdiv.append(button);
						 
						//write the content of the file in the textarea
						for (i in response[0][x]) {
							var obj = document.getElementById(file);
							var txt = document.createTextNode(response[0][x][i]);
							//Hide n4d port on allowed ports textbox
							if  (response[0][x][i] != 9779){
								obj.appendChild(txt);
							}
						}
						
						// Binding events
						$(button).bind("click", function(event){
							id=($(event.target).attr("id"));
							self.saveFile(id);
							
						})
						
						
						
					}
                                },
                                error: function(jqXHR, status, error) {
                                        bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
                                }
                        })
	}

	
	this.switchAdvanced=function switchAdvanced(){
		self.show_advanced=!self.show_advanced;
		if (!self.show_advanced){
			$("#AllowedPorts").hide(500);
			$("#DenyDomainsExpr").hide(500);			
			$("#AdvancedSelector").html(i18n.gettext("show.advanced.options"));			
		} else
		{
			$("#AllowedPorts").show(500);
			$("#DenyDomainsExpr").show(500);
			$("#AdvancedSelector").html(i18n.gettext("hide.advanced.options"));
		}		
	}
	
	
	this.switchMenu=function switchMenu(){
		self.show_menu=!self.show_menu;
		if (!self.show_menu){
			$("#menu").hide(500);
		} else
		{
			$("#menu").show(500);
			$("#menu").bind("mouseleave", function (){
				$("#menu").hide(500);
				self.show_menu=false;
				});
			
		}		
	}
	
	this.loadsettings=function loadsettings(dir){
				// Loading templates
		$.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'set_template',
			params: [[sessionStorage.username , sessionStorage.password],"LliurexGuardEasy", dir],
	       	success: function(response,status,jqXHR){
					$("#AllowedDomains").empty();
					$("#DenyDomains").empty();
					$("#AllowedPorts").empty();
					$("#DenyDomainsExpr").empty();
					self.getList();
					$("#menu").hide(500);
					self.show_menu=false;

					
					
				},
					error: function(jqXHR, status, error) {
							bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
				}
		})
		
	}
	
	this.createMenu=function createMenu(){
		
		var entry=$(document.createElement("div")).html(i18n.gettext('default.config')).addClass("menu_title");
		$("#presets").append(entry);
		
		var entry=$(document.createElement("div")).html(i18n.gettext('custom.config')).addClass("menu_title");
		$("#custom").append(entry);
		
		var entry=$(document.createElement("div")).html(i18n.gettext('backup')).addClass("menu_title");
		$("#backup").append(entry);
		
		// Loading templates
		$.xmlrpc({
			url: 'https://'+sessionStorage.server+':9779',
			methodName: 'get_templates',
				params: ['',"LliurexGuardEasy"],

	       	    success: function(response,status,jqXHR){
					for (i in response[0]) {
						var name=JSON.parse(response[0][i])["template"];
						var desc=JSON.parse(response[0][i])["desc"];
						var type=JSON.parse(response[0][i])["class"];
						
						var option=$(document.createElement("div")).html(desc).addClass("menu_entry").attr("template",name).attr("desc", desc);
						option.bind("click", function(event){
							// Settint template name
							
							//alert($(event.target).attr("template"));
							var r=false; // If we are restoring a backup, we don't like to ask for save current config
							if($(event.target).attr("template")!="backup")
							  bootbox.dialog({
								message: i18n.gettext("ask.for.save.config"),
								title: i18n.gettext("save.config"),
								buttons: {
									success: {
										label: i18n.gettext("yes"),
										className: "btn-success",
										callback: function() {
											$.xmlrpc({
											url: 'https://'+sessionStorage.server+':9779',
											methodName: 'create_backup',
											params: [[sessionStorage.username , sessionStorage.password],"LliurexGuardEasy", "backup", "Restore Backup", "backup"],
											success: function(response,status,jqXHR){
												self.loadsettings($(event.target).attr("template"));
												self.restartService($(event.target).attr("desc"));
												},			
											error: function(jqXHR, status, error) {
												bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
												}
										  })
											
										}
									},
									danger: {
										label: i18n.gettext("no"),
										className: "btn-danger",
										callback: function() {
											self.loadsettings($(event.target).attr("template"));
											self.restartService($(event.target).attr("desc"));
										}
									}
									}
										
								});
							else // Restoring backup
							{
								self.loadsettings($(event.target).attr("template"));
								self.restartService(i18n.gettext("backup.restored"));
							}
							
					
					
					
							
							});
						
						
						if (type=="default"){
							$("#presets").append(option);
						} else if (type=="custom") {
							delbt=$(document.createElement("div")).attr("template",name).addClass("btdelete").attr("desc",desc);
							delbt.bind("click",function(event){
								event.stopPropagation();
								
								bootbox.dialog({
								message: i18n.gettext("ask.remove")+$(event.target).attr("template")+"?",
								title: i18n.gettext("deleting"), // "Deleting"
								buttons: {
									success: {
										label: i18n.gettext("yes"),
										className: "btn-success",
										callback: function() {
											$.xmlrpc({
												url: 'https://'+sessionStorage.server+':9779',
												methodName: 'remove_custom',
												params: [[sessionStorage.username , sessionStorage.password],"LliurexGuardEasy", $(event.target).attr("template")],
												success: function(response,status,jqXHR){
													$("#presets").empty();
													$("#custom").empty();
													$("#backup").empty();
													self.createMenu();
													},
												error: function(jqXHR, status, error) {
																bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
													}
											  })
											
										}
									},
									danger: {
										label: i18n.gettext("no"),
										className: "btn-danger",
										callback: function() {}
									}
								}
										
							});
							
							})
							
							
							$(option).append(delbt);
							$("#custom").append(option);
						} else if ( (type=="backup") ) {
							$("#backup").append(option);
							
						}
					}
				},
					error: function(jqXHR, status, error) {
							bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
				}
				
		})
	
		var optionsave=$(document.createElement("div")).html(i18n.gettext("save.current")).addClass("menu_entry").attr("template","save");
		
		optionsave.bind("click", function(event){
			var Name = "";
			
			bootbox.prompt(i18n.gettext("ask.description"), function(result) {
				if (result === null) {
					
				} else {
					Name=result;
					
					var shortname=Name.replace(/ /g,'');
					$.xmlrpc({
						url: 'https://'+sessionStorage.server+':9779',
						methodName: 'create_backup',
						params: [[sessionStorage.username , sessionStorage.password],"LliurexGuardEasy", shortname, Name, "custom"],
						success: function(response,status,jqXHR){
							self.loadsettings($(event.target).attr("template"));
							$("#presets").empty();
							$("#custom").empty();
							$("#backup").empty();
							self.createMenu();
							},
								error: function(jqXHR, status, error) {
										bootbox.alert("Status: "+status+"\nError: N4D server is down "+error);
							}
					})
					
				  }
				});
				
		})
		
		$("#custom").append(optionsave);
		
		/*var entry=$(document.createElement("div")).html('preset1').addClass("menu_entry");
		$("#menu").append(entry);
		var entry=$(document.createElement("div")).html('preset2').addClass("menu_entry");
		$("#menu").append(entry);
		*/
		/*var entry=$(document.createElement("div")).html('Personal Settings').addClass("menu_title");
		$("#menu").append(entry);*/
		
		
	
	}
	
		this.showhelp=function showhelp(help_for){
		$("#help_title").empty();
		$("#help_text").empty();
		title="";
		content="";
		switch(help_for){
			case "allow_dst_domains":
				title=i18n.gettext("allow.dst.domains.help.title");
				content=i18n.gettext("allow.dst.domains.help.content");
								
			break;
			
			case "deny_dst_domains":
				title=i18n.gettext("deny.dst.domains.help.title");
				content=i18n.gettext("deny.dst.domains.help.content");
			break;
			
			case "deny_dst_domains_expr":
				title=i18n.gettext("deny.dst.domains.expr.help.title");
				content=i18n.gettext("deny.dst.domains.expr.help.content");

			break;
			
			case "allow_ssl_ports":
				title=i18n.gettext("allow.ssl.ports.help.title");
				content=i18n.gettext("allow.ssl.ports.help.content");

			break;
		}
		
		
		$("#help_title").html(title);
		$("#help_text").html(content);
		
		
		
		$("#help").unbind("click");
		//$("#black").unbind("click");
		$("#help").bind("click", function(){
				$("#help").hide(500);
				$("#black").hide(500);
			});
		/*$("#black").bind("click",function(){
				$("#help").hide(500);
				$("#black").hide(500);
			});
		*/
		$("#help").show(500);
		// $("#black").show(500);
		
		
		
		
		
	}

	
}


$(document).ready(function() {
	
	$("#help").hide();
	$("#black").hide();
	
	var llxguard=new LliurexGuard();
	llxguard.getList();
	llxguard.createMenu();
	var cur_settings=$(document.createElement("span")).addClass("config_name").attr("id", "loaded_config").html(i18n.gettext("showing.cfg.for.running"));
	var configstring=$(document.createElement("span")).addClass("connect_string").html(i18n.gettext("info.connectedto",[sessionStorage.server,sessionStorage.username]));
	
   	$("#bottom").append(configstring);
	$("#bottom").append(cur_settings);
	
	$("#AdvancedSelector").html(i18n.gettext("show.advanced.options"));
	
	$("#AllowedPorts").hide();
	$("#DenyDomainsExpr").hide();
	$("#menu").hide();
	
	$("#AdvancedSelector").bind("click", llxguard.switchAdvanced);
	
	$("#menu_button").bind("click", llxguard.switchMenu);
	
	$("#config_name").html(i18n.gettext("current.config"));
	
	//$().bind("click", llxguard.switchAdvanced())


})

